export declare type ElementOf<A extends any[]> = A extends (infer R)[] ? R : never;
export declare type GetFirst<A extends any[]> = A[0] extends any ? A[0] : never;
export declare type GetLast<A> = A extends [] ? never : A extends [any] ? A[0] : A extends [any, ...infer R] ? GetLast<R> : never;
export declare type Split<S extends string, Delimeter extends string> = S extends `${infer T}${Delimeter}${infer U}` ? [T, ...Split<U, Delimeter>] : [S];
declare type TrimLeft<S extends string> = S extends ` ${infer R}` ? TrimLeft<R> : S;
declare type TrimRight<S extends string> = S extends `${infer R} ` ? TrimRight<R> : S;
export declare type Trim<S extends string> = TrimLeft<TrimRight<S>>;
declare type ClassSelector = '.';
declare type IDSelector = '#';
declare type AttributeSelector = '[';
declare type BasicSelectors = ClassSelector | IDSelector | AttributeSelector;
declare type PseudoClasses = ':';
declare type DescendantCombinator = ' ';
declare type ChildCombinator = '>';
declare type GeneralSiblingCombinator = '~';
declare type AdjacentSiblingCombinator = '+';
declare type ColumnCombinator = '|';
declare type Combinators = DescendantCombinator | ChildCombinator | GeneralSiblingCombinator | AdjacentSiblingCombinator | ColumnCombinator;
declare type SplitWithSelctor<Query extends string, Selector extends BasicSelectors | PseudoClasses> = GetFirst<Split<Query, Selector>>;
declare type TagNameFromToken<Token extends string> = SplitWithSelctor<SplitWithSelctor<SplitWithSelctor<SplitWithSelctor<Token, ClassSelector>, IDSelector>, AttributeSelector>, PseudoClasses>;
declare type LastToken<SingleQuery extends string> = GetLast<Split<Trim<SingleQuery>, Combinators>>;
export declare type GetHTMLElementByTagName<T extends string> = T extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[T] : T extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[T] : Element;
export declare type QueriedHTMLElement<Query extends string> = GetHTMLElementByTagName<TagNameFromToken<LastToken<Query>>>;
export {};
